
#include <stdio.h>
#include <stdlib.h>

typedef struct _DBI {
	char *driver;
	char *host;
	unsigned int port;
	
	char *user;
	char *password;
	
	char *database;
	
	void (*disconnect)();
	void (*select_db)();
} *DBI;


void DBI_select_db (DBI self, char *database) {
	self->database = database;
}

void DBI_query  (DBI self, char *query) {
	printf("%s\n", query);
}

void DBI_disconnect (DBI self) {
	free(self);
}




DBI DBI_connect (char *driver, char *host, unsigned int port, char *user, char *password) {
	DBI self = (DBI) malloc(sizeof(struct _DBI));
	
	self->driver = driver;
	self->host = host;
	self->port = port;
	self->user = user;
	self->password = password;
		
	self->disconnect = DBI_disconnect;
	self->select_db = DBI_select_db;
	
	return self;
}

int main () {
	
	
	DBI dbh = DBI_connect("mysql", "localhost", 3306, "daniels", "secret");
	
	dbh->select_db(dbh, "PAL");
	
	dbh->query(dbh, "select * from authors");
	
	while (dbh->fetchrow(dbh)) {
		puts( dbh->getCol(dbh, "haha") );
	}
	
	printf("%s\n", dbh->database);
	printf("%s\n", dbh->driver);
	
	
	return 0;
}





